//::///////////////////////////////////////////////
//:: Default:On Death
//:: NW_C2_DEFAULT7
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Shouts to allies that they have been killed
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 25, 2001
//:://////////////////////////////////////////////
#include "NW_I0_GENERIC"

void main()
{
    int nClass = GetLevelByClass(CLASS_TYPE_COMMONER);
    int nAlign = GetAlignmentGoodEvil(OBJECT_SELF);
    if(nClass > 0 && (nAlign == ALIGNMENT_GOOD || nAlign == ALIGNMENT_NEUTRAL))
    {
        object oKiller = GetLastKiller();
        AdjustAlignment(oKiller, ALIGNMENT_EVIL, 5);
    }

    SpeakString("NW_I_AM_DEAD", TALKVOLUME_SILENT_TALK);
    //Shout Attack my target, only works with the On Spawn In setup
    SpeakString("NW_ATTACK_MY_TARGET", TALKVOLUME_SILENT_TALK);
    if(GetSpawnInCondition(NW_FLAG_DEATH_EVENT))
    {
        SignalEvent(OBJECT_SELF, EventUserDefined(1007));
    }

//  Modified By: Dalantriel Jul 22, 2002
//  Raze the temple if killed by a non-PC

    object oKiller = GetLastKiller();

    if(!(GetIsPC(oKiller)))
    {
    SoundObjectStop(GetObjectByTag("MagicCrystalGoodSeal"));
    DestroyObject(GetObjectByTag("Boulder"));
    SoundObjectPlay(GetObjectByTag("Boom"));
    SoundObjectPlay(GetObjectByTag("MagicPortalEvilSeal"));


// Add evil effects
    location loc = GetLocation(GetObjectByTag("MagicSparksWhite"));
    CreateObject(OBJECT_TYPE_PLACEABLE, "unholylight", loc, TRUE);


// Set Good NPC to dead and add Journal Entry
    object oTrashCan = GetObjectByTag("TrashCan");
    SetLocalInt(oTrashCan, "nGoodNPCDead", 1);

    AddJournalQuestEntry("Category000", 7, GetFirstPC(), TRUE, TRUE);
    }

// Else add PC killed Henrick to Journal
    else
    {
    AddJournalQuestEntry("Category000", 8, GetFirstPC(), TRUE, TRUE);
    // Set Good NPC to dead and add Journal Entry
    object oTrashCan = GetObjectByTag("TrashCan");
    SetLocalInt(oTrashCan, "nGoodNPCDead", 1);
    }

}
